Index: drivers/dahdi/wcb4xxp/base.c
===================================================================
--- drivers/dahdi/wcb4xxp/base.c	(revision 7107)
+++ drivers/dahdi/wcb4xxp/base.c	(working copy)
@@ -20,6 +20,26 @@
  * this program for more details.
  */
 
+#if defined(__FreeBSD__)
+#include <sys/types.h>
+#include <sys/bus.h>
+#include <sys/module.h>
+#include <sys/queue.h>
+#include <sys/rman.h>
+#include <sys/systm.h>
+
+#include <machine/bus.h>
+#include <machine/stdarg.h>
+#include <dev/pci/pcireg.h>
+#include <dev/pci/pcivar.h>
+
+#define mb()
+#define wmb()
+#define mmiowb()
+
+#define printk_ratelimit()	1
+
+#else /* !__FreeBSD__ */
 #include <linux/autoconf.h>
 #include <linux/init.h>
 
@@ -42,6 +62,7 @@
 #include <linux/timer.h>	/* timer_struct */
 #include <linux/moduleparam.h>
 #include <linux/proc_fs.h>
+#endif /* !__FreeBSD__ */
 
 #include <dahdi/kernel.h>
 
@@ -55,7 +76,6 @@
 #define IS_SET(x, i)     (((x) & BIT(i)) != 0)
 #define BITMASK(i)      (((u64)1 << (i)) - 1)
 
-
 #if (DAHDI_CHUNKSIZE != 8)
 #error Sorry, wcb4xxp does not support chunksize != 8
 #endif
@@ -88,8 +108,10 @@
 #ifdef LOOPBACK_SUPPORTED
 static int loopback = 0;
 #endif
+#if !defined(__FreeBSD__)
 static int milliwatt = 0;
 static int pedanticpci = 0;
+#endif
 static int teignorered = 0;
 static int alarmdebounce = 500;
 static int vpmsupport = 1;
@@ -170,8 +192,82 @@
  * has the effect of flushing any pending PCI writes.
  */
 
+#if defined(__FreeBSD__)
+static void device_rlprintf(int pps, device_t dev, const char *fmt, ...)
+{
+	va_list ap;
+	static struct timeval last_printf;
+	static int count;
+
+	if (ppsratecheck(&last_printf, &count, pps)) {
+		va_start(ap, fmt);
+		device_print_prettyname(dev);
+		vprintf(fmt, ap);
+		va_end(ap);
+	}
+}
+
+#define DPRINTF(dev, fmt, args...)	device_rlprintf(10, dev, fmt, ##args)
+
 static inline unsigned char __pci_in8(struct b4xxp *b4, const unsigned int reg)
 {
+        return bus_space_read_1(
+	    rman_get_bustag(b4->mem_res), rman_get_bushandle(b4->mem_res),
+	    reg);
+}
+
+static inline unsigned short __pci_in16(struct b4xxp *b4, const unsigned int reg)
+{
+        return bus_space_read_2(
+	    rman_get_bustag(b4->mem_res), rman_get_bushandle(b4->mem_res),
+	    reg);
+}
+
+static inline unsigned int __pci_in32(struct b4xxp *b4, const unsigned int reg)
+{
+        return bus_space_read_4(
+	    rman_get_bustag(b4->mem_res), rman_get_bushandle(b4->mem_res),
+	    reg);
+}
+
+static inline unsigned char __reg_in8(struct b4xxp *b4, const unsigned int reg)
+{
+        return bus_space_read_1(
+	    rman_get_bustag(b4->io_res), rman_get_bushandle(b4->io_res),
+	    reg);
+}
+
+static inline void __pci_out8(struct b4xxp *b4, const unsigned int reg, const unsigned char val)
+{
+        bus_space_write_1(
+	    rman_get_bustag(b4->mem_res), rman_get_bushandle(b4->mem_res),
+	    reg, val);
+}
+
+static inline void __pci_out32(struct b4xxp *b4, const unsigned int reg, const unsigned int val)
+{
+        bus_space_write_4(
+	    rman_get_bustag(b4->mem_res), rman_get_bushandle(b4->mem_res),
+	    reg, val);
+}
+
+static inline void __reg_out16(struct b4xxp *b4, const unsigned int reg, const unsigned short val)
+{
+        bus_space_write_2(
+	    rman_get_bustag(b4->io_res), rman_get_bushandle(b4->io_res),
+	    reg, val);
+}
+
+static inline void __reg_out32(struct b4xxp *b4, const unsigned int reg, const unsigned int val)
+{
+        bus_space_write_4(
+	    rman_get_bustag(b4->io_res), rman_get_bushandle(b4->io_res),
+	    reg, val);
+}
+
+#else /* !__FreeBSD__ */
+static inline unsigned char __pci_in8(struct b4xxp *b4, const unsigned int reg)
+{
 	unsigned char ret = ioread8(b4->addr + reg);
 
 #ifdef DEBUG_LOWLEVEL_REGS
@@ -215,6 +311,11 @@
 	return ret;
 }
 
+static inline unsigned char __reg_in8(struct b4xxp *b4, const unsigned int reg)
+{
+	return ioread8(b4->ioaddr + reg);
+}
+
 static inline void __pci_out32(struct b4xxp *b4, const unsigned int reg, const unsigned int val)
 {
 #ifdef DEBUG_LOWLEVEL_REGS
@@ -243,7 +344,17 @@
 	}
 }
 
+static inline void __reg_out16(struct b4xxp *b4, const unsigned int reg, const unsigned short val)
+{
+	iowrite16(val, b4->ioaddr + reg);
+}
 
+static inline void __reg_out32(struct b4xxp *b4, const unsigned int reg, const unsigned int val)
+{
+	iowrite32(val, b4->ioaddr + reg);
+}
+#endif /* !__FreeBSD__ */
+
 /*
  * Standard I/O access functions
  * uses spinlocks to protect against multiple I/O accesses
@@ -291,7 +402,7 @@
 
 #ifndef DEBUG_LOWLEVEL_REGS
 	if (unlikely(DBG_REGS)) {
-		dev_dbg(b4->dev, "read 0x%02x from 0x%p\n", ret, b4->addr + reg);
+		dev_dbg(b4->dev, "read 0x%02x from 0x%x\n", ret, reg);
 	}
 #endif
 	return ret;
@@ -308,7 +419,7 @@
 
 #ifndef DEBUG_LOWLEVEL_REGS
 	if (unlikely(DBG_REGS)) {
-		dev_dbg(b4->dev, "read 0x%04x from 0x%p\n", ret, b4->addr + reg);
+		dev_dbg(b4->dev, "read 0x%04x from 0x%x\n", ret, reg);
 	}
 #endif
 	return ret;
@@ -325,7 +436,7 @@
 
 #ifndef DEBUG_LOWLEVEL_REGS
 	if (unlikely(DBG_REGS)) {
-		dev_dbg(b4->dev, "read 0x%04x from 0x%p\n", ret, b4->addr + reg);
+		dev_dbg(b4->dev, "read 0x%04x from 0x%x\n", ret, reg);
 	}
 #endif
 	return ret;
@@ -337,7 +448,7 @@
 
 #ifndef DEBUG_LOWLEVEL_REGS
 	if (unlikely(DBG_REGS)) {
-		dev_dbg(b4->dev, "writing 0x%02x to 0x%p\n", val, b4->addr + reg);
+		dev_dbg(b4->dev, "writing 0x%02x to 0x%x\n", val, reg);
 	}
 #endif
 	spin_lock_irqsave(&b4->reglock, irq_flags);
@@ -351,7 +462,7 @@
 
 #ifndef DEBUG_LOWLEVEL_REGS
 	if (unlikely(DBG_REGS)) {
-		dev_dbg(b4->dev, "writing 0x%02x to 0x%p\n", val, b4->addr + reg);
+		dev_dbg(b4->dev, "writing 0x%02x to 0x%x\n", val, reg);
 	}
 #endif
 	spin_lock_irqsave(&b4->reglock, irq_flags);
@@ -479,9 +590,9 @@
 		cipv=0x5800;
 
 /* select local bridge port address by writing to CIP port */
-	iowrite16(cipv, b4->ioaddr + 4);
+	__reg_out16(b4, 4, cipv);
 	wmb();
-	data = ioread8(b4->ioaddr);
+	data = __reg_in8(b4, 0);
 
 /* restore R_CTRL for normal PCI read cycle speed */
 	b4xxp_setreg8(b4, R_CTRL, 0x0);
@@ -503,7 +614,7 @@
 		cipv=0x5800;
 
 /* select local bridge port address by writing to CIP port */
-	iowrite16(cipv, b4->ioaddr + 4);
+	__reg_out16(b4, 4, cipv);
 	wmb();
 
 /* define a 32 bit dword with 4 identical bytes for write sequence */
@@ -516,7 +627,7 @@
  * the number of write accesses is undefined but >=1 and depends on the next PCI transaction
  * during write sequence on the local bus
  */
-	iowrite32(datav, b4->ioaddr);
+	__reg_out32(b4, 0, datav);
 	wmb();
 	flush_pci();
 }
@@ -1506,7 +1617,7 @@
 /* select RX FIFO */
 	hfc_setreg_waitbusy(b4, R_FIFO, (fifo << V_FIFO_NUM_SHIFT) | V_FIFO_DIR | V_REV);
 
-	get_Z(z1, z2, zlen);
+	get_Z(b4, z1, z2, zlen);
 
 /* TODO: error checking, full FIFO mostly */
 
@@ -1574,8 +1685,8 @@
 {
 	int f1, f2, flen, z1, z2, zlen;
 
-	get_F(f1, f2, flen);
-	get_Z(z1, z2, zlen);
+	get_F(b4, f1, f2, flen);
+	get_Z(b4, z1, z2, zlen);
 
 	sprintf(buf, "%s: (fifo %d): f1/f2/flen=%d/%d/%d, z1/z2/zlen=%d/%d/%d\n", prefix, fifo, f1, f2, flen, z1, z2, zlen);
 }
@@ -1620,8 +1731,8 @@
 
 	spin_lock_irqsave(&b4->fifolock, irq_flags);
 	hfc_setreg_waitbusy(b4, R_FIFO, (fifo << V_FIFO_NUM_SHIFT) | V_FIFO_DIR);
-	get_F(f1, f2, flen);
-	get_Z(z1, z2, zlen);
+	get_F(b4, f1, f2, flen);
+	get_Z(b4, z1, z2, zlen);
 	debug_fz(b4, fifo, "hdlc_rx_frame", debugbuf);
 	spin_unlock_irqrestore(&b4->fifolock, irq_flags);
 
@@ -1668,7 +1779,7 @@
 /* Frame received, increment F2 and get an updated count of frames left */
 	spin_lock_irqsave(&b4->fifolock, irq_flags);
 	hfc_setreg_waitbusy(b4, A_INC_RES_FIFO, V_INC_F);
-	get_F(f1, f2, flen);
+	get_F(b4, f1, f2, flen);
 	spin_unlock_irqrestore(&b4->fifolock, irq_flags);
 
 	/* If this channel is not configured with a signalling span we don't
@@ -1736,7 +1847,7 @@
 	spin_lock_irqsave(&b4->fifolock, irq_flags);
 	hfc_setreg_waitbusy(b4, R_FIFO, (fifo << V_FIFO_NUM_SHIFT));
 
-	get_Z(z1, z2, zlen);
+	get_Z(b4, z1, z2, zlen);
 	debug_fz(b4, fifo, "hdlc_tx_frame", debugbuf);
 
 /* TODO: check zlen, etc. */
@@ -1964,8 +2075,8 @@
 	/* Write Leds...*/
 	leddw = lled << 24 | lled << 16 | lled << 8 | lled;
 	b4xxp_setreg8(b4, R_BRG_PCM_CFG, 0x21);
-	iowrite16(0x4000, b4->ioaddr + 4);
-	iowrite32(leddw, b4->ioaddr);
+	__reg_out16(b4, 4, 0x4000);
+	__reg_out32(b4, 0, leddw);
 	b4xxp_setreg8(b4, R_BRG_PCM_CFG, 0x20);
 
 	if (b4->blinktimer == 0xff)
@@ -2306,7 +2417,11 @@
 		bspan = &b4->spans[i];
 		bspan->parent = b4;
 
+#if defined(__FreeBSD__)
+		bspan->span.irq = bus_get_resource_start(b4->dev, SYS_RES_IRQ, b4->irq_rid);
+#else
 		bspan->span.irq = b4->pdev->irq;
+#endif
 		bspan->span.pvt = bspan;
 		bspan->span.spantype = (bspan->te_mode) ? "TE" : "NT";
 		bspan->span.offset = i;
@@ -2325,10 +2440,14 @@
 		sprintf(bspan->span.desc, "B4XXP (PCI) Card %d Span %d", b4->cardno, i+1);
 		bspan->span.manufacturer = "Digium";
 		dahdi_copy_string(bspan->span.devicetype, b4->variety, sizeof(bspan->span.devicetype));
+#if !defined(__FreeBSD__)
 		sprintf(bspan->span.location, "PCI Bus %02d Slot %02d",
 			b4->pdev->bus->number, PCI_SLOT(b4->pdev->devfn) + 1);
+#endif
 
+#if !defined(__FreeBSD__)
 		bspan->span.owner = THIS_MODULE;
+#endif
 		bspan->span.spanconfig = b4xxp_spanconfig;
 		bspan->span.chanconfig = b4xxp_chanconfig;
 		bspan->span.startup = b4xxp_startup;
@@ -2379,8 +2498,13 @@
 
 	/* Make sure it's really for us */
 	status = __pci_in8(b4, R_STATUS);
-	if (!(status & HFC_INTS))
+	if (!(status & HFC_INTS)) {
+#if defined(__FreeBSD__)
+		return (FILTER_STRAY);
+#else
 		return IRQ_NONE;
+#endif
+	}
 
 /*
  * since the interrupt is for us, read in the FIFO and misc IRQ status registers.
@@ -2420,10 +2544,20 @@
 	}
 
 /* kick off bottom-half handler */
-	/* tasklet_hi_schedule(&b4->b4xxp_tlet); */
+#if 0
+#if defined(__FreeBSD__)
+	return (FILTER_HANDLED | FILTER_SCHEDULE_THREAD);
+#else
+	tasklet_hi_schedule(&b4->b4xxp_tlet);
+#endif
+#endif
 	b4xxp_bottom_half((unsigned long)b4);
 
+#if defined(__FreeBSD__)
+	return (FILTER_HANDLED);
+#else
 	return IRQ_RETVAL(1);
+#endif
 }
 
 
@@ -2664,54 +2798,25 @@
 	return b4xxp_spanconfig(&b4->spans[0].span, &lc);
 }
 
-static int __devinit b4xx_probe(struct pci_dev *pdev, const struct pci_device_id *ent)
+static int b4xxp_setup_intr(struct b4xxp *b4);
+static void b4xxp_release_intr(struct b4xxp *b4);
+
+static int b4xxp_register(struct b4xxp *b4, struct devtype *dt)
 {
 	int x, ret;
-	struct b4xxp *b4;
-	struct devtype *dt;
 
-	dt = (struct devtype *)(ent->driver_data);
-	dev_info(&pdev->dev, "probe called for b4xx...\n");
-
-	if ((ret = pci_enable_device(pdev)))
-		goto err_out_disable_pdev;
-
-	if ((ret = pci_request_regions(pdev, dt->desc))) {
-		dev_err(&pdev->dev, "Unable to request regions!\n");
-		goto err_out_disable_pdev;
-	}
-
-	if (!pdev->irq) {			/* we better have an IRQ */
-		dev_err(&pdev->dev, "Device has no associated IRQ?\n");
-		ret = -EIO;
-		goto err_out_release_regions;
-	}
-
-	if (!(b4 = kzalloc(sizeof(struct b4xxp), GFP_KERNEL))) {
-		dev_err(&pdev->dev, "Couldn't allocate memory for b4xxp structure!\n");
-		ret = -ENOMEM;
-		goto err_out_release_regions;
-	}
-
 /* card found, enabled and main struct allocated.  Fill it out. */
 	b4->variety = dt->desc;
 	b4->card_type = dt->card_type;
-	b4->pdev = pdev;
-	b4->dev = &pdev->dev;
-	pci_set_drvdata(pdev, b4);
 
-	b4->ioaddr = pci_iomap(pdev, 0, 0);
-	b4->addr = pci_iomap(pdev, 1, 0);
-	b4->irq = pdev->irq;
-
 	spin_lock_init(&b4->reglock);
 	spin_lock_init(&b4->seqlock);
 	spin_lock_init(&b4->fifolock);
 
 	x = b4xxp_getreg8(b4, R_CHIP_ID);
 	if ((x != 0xc0) && (x != 0x80)) {		/* wrong chip? */
-		dev_err(&pdev->dev, "Unknown/unsupported controller detected (R_CHIP_ID = 0x%02x)\n", x);
-		goto err_out_free_mem;
+		dev_err(b4->dev, "Unknown/unsupported controller detected (R_CHIP_ID = 0x%02x)\n", x);
+		return _RETVAL(ENXIO);
 	}
 
 /* future proofing */
@@ -2728,11 +2833,13 @@
 	b4->syncspan = -1;		/* sync span is unknown */
 	if (b4->numspans > MAX_SPANS_PER_CARD) {
 		dev_err(b4->dev, "Driver does not know how to handle a %d span card!\n", b4->numspans);
-		goto err_out_free_mem;
+		return _RETVAL(ENXIO);
 	}
 
+#if !defined(__FreeBSD__)
 	dev_info(b4->dev, "Identified %s (controller rev %d) at %p, IRQ %i\n",
 		b4->variety, b4->chiprev, b4->ioaddr, b4->irq);
+#endif
 
 /* look for the next free card structure */
 	for (x=0; x < MAX_B4_CARDS; x++) {
@@ -2741,8 +2848,8 @@
 	}
 
 	if (x >= MAX_B4_CARDS) {
-		dev_err(&pdev->dev, "Attempt to register more than %i cards, aborting!\n", MAX_B4_CARDS);
-		goto err_out_free_mem;
+		dev_err(b4->dev, "Attempt to register more than %i cards, aborting!\n", MAX_B4_CARDS);
+		return _RETVAL(ENXIO);
 	}
 
 /* update the cards array, make sure the b4xxp struct knows where in the array it is */
@@ -2751,16 +2858,9 @@
 
 	b4xxp_init_stage1(b4);
 
-	if (request_irq(pdev->irq, b4xxp_interrupt, DAHDI_IRQ_SHARED_DISABLED, "b4xxp", b4)) {
-		dev_err(b4->dev, "Unable to request IRQ %d\n", pdev->irq);
-		ret = -EIO;
+	if ((ret = b4xxp_setup_intr(b4)))
 		goto err_out_del_from_card_array;
-	}
 
-/* initialize the tasklet structure */
-/* TODO: perhaps only one tasklet for any number of cards in the system... don't need one per card I don't think. */
-	tasklet_init(&b4->b4xxp_tlet, b4xxp_bottom_half, (unsigned long)b4);
-
 /* interrupt allocated and tasklet initialized, it's now safe to finish initializing the hardware */
 	b4xxp_init_stage2(b4);
 	hfc_init_all_st(b4);
@@ -2774,8 +2874,6 @@
 		}
 	}
 
-
-
 #if 0
 	/* Launch cards as appropriate */
 	for (;;) {
@@ -2813,7 +2911,7 @@
 	};
 
 	b4xxp_init_stage1(b4);			/* full reset, re-init to "no-irq" state */
-	free_irq(pdev->irq, b4);
+	b4xxp_release_intr(b4);
 
 err_out_del_from_card_array:
 	for (x=0; x < MAX_B4_CARDS; x++) {
@@ -2825,8 +2923,296 @@
 	}
 
 	if (x >= MAX_B4_CARDS)
-		dev_err(&pdev->dev, "b4 struct @ %p should be in cards array but isn't?!\n", b4);
+		dev_err(b4->dev, "b4 struct @ %p should be in cards array but isn't?!\n", b4);
 
+	return ret;
+}
+
+static void b4xxp_unregister(struct b4xxp *b4)
+{
+	int i;
+
+	b4->shutdown = 1;
+
+	for (i = b4->numspans - 1; i >= 0; i--) {
+		dahdi_unregister(&b4->spans[i].span);
+	}
+
+	b4xxp_init_stage1(b4);
+
+	spin_lock_destroy(&b4->reglock);
+	spin_lock_destroy(&b4->seqlock);
+	spin_lock_destroy(&b4->fifolock);
+}
+
+static struct pci_device_id b4xxp_ids[] __devinitdata =
+{
+	{ 0xd161, 0xb410, PCI_ANY_ID, PCI_ANY_ID, 0, 0, (unsigned long)&wcb4xxp },
+	{ 0x1397, 0x16b8, 0x1397, 0xe552, 0, 0, (unsigned long)&hfc8s },
+	{ 0x1397, 0x08b4, 0x1397, 0xb520, 0, 0, (unsigned long)&hfc4s },
+	{ 0x1397, 0x08b4, 0x1397, 0xb556, 0, 0, (unsigned long)&hfc2s },
+	{ 0x1397, 0x08b4, 0x1397, 0xe884, 0, 0, (unsigned long)&hfc2s_OV },
+	{ 0x1397, 0x08b4, 0x1397, 0xe888, 0, 0, (unsigned long)&hfc4s_OV },
+	{ 0x1397, 0x16b8, 0x1397, 0xe998, 0, 0, (unsigned long)&hfc8s_OV },
+	{ 0x1397, 0x08b4, 0x1397, 0xb566, 0, 0, (unsigned long)&hfc2s_BN },
+	{ 0x1397, 0x08b4, 0x1397, 0xb560, 0, 0, (unsigned long)&hfc4s_BN },
+	{ 0x1397, 0x16b8, 0x1397, 0xb562, 0, 0, (unsigned long)&hfc8s_BN },
+	{ 0, }
+};
+
+#if defined(__FreeBSD__)
+static void b4xxp_release_intr(struct b4xxp *b4)
+{
+	if (b4->irq_handle != NULL) {
+		bus_teardown_intr(b4->dev, b4->irq_res, b4->irq_handle);
+		b4->irq_handle = NULL;
+	}
+
+	if (b4->irq_res != NULL) {
+		bus_release_resource(b4->dev, SYS_RES_IRQ, b4->irq_rid, b4->irq_res);
+		b4->irq_res = NULL;
+	}
+}
+
+static void b4xxp_release_resources(struct b4xxp *b4)
+{
+        /* disconnect the interrupt handler */
+	b4xxp_release_intr(b4);
+
+	/* release I/O range */
+	if (b4->io_res != NULL) {
+		bus_deactivate_resource(b4->dev, SYS_RES_IOPORT, b4->io_rid, b4->mem_res);
+		bus_release_resource(b4->dev, SYS_RES_IOPORT, b4->io_rid, b4->io_res);
+		b4->io_res = NULL;
+	}
+
+	/* release memory window */
+	if (b4->mem_res != NULL) {
+		bus_deactivate_resource(b4->dev, SYS_RES_MEMORY, b4->mem_rid, b4->mem_res);
+		bus_release_resource(b4->dev, SYS_RES_MEMORY, b4->mem_rid, b4->mem_res);
+		b4->mem_res = NULL;
+	}
+}
+
+static int b4xxp_setup_intr(struct b4xxp *b4)
+{
+	int error;
+
+	b4->irq_res = bus_alloc_resource_any(
+	     b4->dev, SYS_RES_IRQ, &b4->irq_rid, RF_SHAREABLE | RF_ACTIVE);
+	if (b4->irq_res == NULL) {
+		device_printf(b4->dev, "Can't allocate irq resource\n");
+		return _RETVAL(ENXIO);
+	}
+
+	error = bus_setup_intr(
+	    b4->dev, b4->irq_res, INTR_TYPE_CLK, b4xxp_interrupt, NULL,
+	    b4, &b4->irq_handle);
+	if (error) {
+		device_printf(b4->dev, "Can't setup interrupt handler (error %d)\n", error);
+		b4xxp_release_resources(b4);
+		return _RETVAL(ENXIO);
+	}
+
+	return (0);
+}
+
+static struct pci_device_id *
+b4xxp_pci_device_id_lookup(device_t dev)
+{
+	struct pci_device_id *id;
+	uint16_t vendor = pci_get_vendor(dev);
+	uint16_t device = pci_get_device(dev);
+	uint16_t subdevice = pci_get_subdevice(dev);
+
+	for (id = b4xxp_ids; id->vendor != 0; id++) {
+		if (id->vendor != vendor || id->device != device || id->subdevice != subdevice)
+			continue;
+
+		return id;
+	}
+
+	return NULL;
+}
+
+static int
+b4xxp_device_probe(device_t dev)
+{
+        struct pci_device_id *id;
+
+	id = b4xxp_pci_device_id_lookup(dev);
+	if (id == NULL)
+		return _RETVAL(ENXIO);
+
+	/* found device */
+	device_printf(dev, "vendor=%x device=%x subvendor=%x\n",
+	    id->vendor, id->device, id->subdevice);
+	return (0);
+}
+
+static int
+b4xxp_device_attach(device_t dev)
+{
+	int res;
+        struct pci_device_id *id;
+	struct devtype *dt;
+	struct b4xxp *b4;
+
+	id = b4xxp_pci_device_id_lookup(dev);
+	if (id == NULL)
+		return _RETVAL(ENXIO);
+
+	dt = (struct devtype *) id->driver_data;
+	device_set_desc(dev, dt->desc);
+	b4 = device_get_softc(dev);
+	b4->dev = dev;
+
+        /* allocate I/O resource */
+	b4->io_rid = PCIR_BAR(0);
+	b4->io_res = bus_alloc_resource_any(dev, SYS_RES_IOPORT, &b4->io_rid, RF_ACTIVE);
+	if (b4->io_res == NULL) {
+		device_printf(dev, "Can't allocate I/O resource\n");
+		b4xxp_release_resources(b4);
+		return _RETVAL(ENXIO);
+	}
+
+        /* allocate memory resource */
+	b4->mem_rid = PCIR_BAR(1);
+	b4->mem_res = bus_alloc_resource_any(dev, SYS_RES_MEMORY, &b4->mem_rid, RF_ACTIVE);
+	if (b4->mem_res == NULL) {
+		device_printf(dev, "Can't allocate memory resource\n");
+		b4xxp_release_resources(b4);
+		return _RETVAL(ENXIO);
+	}
+
+	/* register */
+	res = b4xxp_register(b4, dt);
+	if (res) {
+		b4xxp_release_resources(b4);
+		return res;
+	}
+
+	return 0;
+}
+
+static int
+b4xxp_device_detach(device_t dev)
+{
+	struct b4xxp *b4 = device_get_softc(dev);
+
+	/* unregister */
+	b4xxp_unregister(b4);
+
+	/* release resources */
+	b4xxp_release_resources(b4);
+
+	return (0);
+}
+
+static int
+b4xxp_device_shutdown(device_t dev)
+{
+	DPRINTF(dev, "wcb4xxp shutdown\n");
+	return (0);
+}
+
+static int
+b4xxp_device_suspend(device_t dev)
+{
+	DPRINTF(dev, "wcb4xxp suspend\n");
+	return (0);
+}
+
+static int
+b4xxp_device_resume(device_t dev)
+{
+	DPRINTF(dev, "wcb4xxp resume\n");
+	return (0);
+}
+
+static device_method_t b4xxp_methods[] = {
+	DEVMETHOD(device_probe,     b4xxp_device_probe),
+	DEVMETHOD(device_attach,    b4xxp_device_attach),
+	DEVMETHOD(device_detach,    b4xxp_device_detach),
+	DEVMETHOD(device_shutdown,  b4xxp_device_shutdown),
+	DEVMETHOD(device_suspend,   b4xxp_device_suspend),
+	DEVMETHOD(device_resume,    b4xxp_device_resume),
+	{ 0, 0 }
+};
+
+static driver_t b4xxp_pci_driver = {
+	"wcb4xxp",
+	b4xxp_methods,
+	sizeof(struct b4xxp)
+};
+
+static devclass_t b4xxp_devclass;
+
+DRIVER_MODULE(wcb4xxp, pci, b4xxp_pci_driver, b4xxp_devclass, 0, 0);
+MODULE_DEPEND(wcb4xxp, pci, 1, 1, 1);
+MODULE_DEPEND(wcb4xxp, dahdi, 1, 1, 1);
+
+#else /* !__FreeBSD__ */
+static int b4xxp_setup_intr(struct b4xxp *b4)
+{
+	if (request_irq(b4->pdev->irq, b4xxp_interrupt, DAHDI_IRQ_SHARED_DISABLED, "b4xxp", b4)) {
+		dev_err(b4->dev, "Unable to request IRQ %d\n", b4->pdev->irq);
+		return _RETVAL(EIO);
+	}
+
+/* initialize the tasklet structure */
+/* TODO: perhaps only one tasklet for any number of cards in the system... don't need one per card I don't think. */
+	tasklet_init(&b4->b4xxp_tlet, b4xxp_bottom_half, (unsigned long)b4);
+	return 0;
+}
+
+static void b4xxp_release_intr(struct b4xxp *b4)
+{
+	free_irq(b4->pdev->irq, b4);
+	tasklet_kill(&b4->b4xxp_tlet);
+}
+
+static int __devinit b4xxp_probe(struct pci_dev *pdev, const struct pci_device_id *ent)
+{
+	int ret;
+	struct b4xxp *b4;
+	struct devtype *dt;
+
+	dt = (struct devtype *)(ent->driver_data);
+	dev_info(&pdev->dev, "probe called for b4xx...\n");
+
+	if ((ret = pci_enable_device(pdev)))
+		goto err_out_disable_pdev;
+
+	if ((ret = pci_request_regions(pdev, dt->desc))) {
+		dev_err(&pdev->dev, "Unable to request regions!\n");
+		goto err_out_disable_pdev;
+	}
+
+	if (!pdev->irq) {			/* we better have an IRQ */
+		dev_err(&pdev->dev, "Device has no associated IRQ?\n");
+		ret = _RETVAL(EIO);
+		goto err_out_release_regions;
+	}
+
+	if (!(b4 = kzalloc(sizeof(struct b4xxp), GFP_KERNEL))) {
+		dev_err(&pdev->dev, "Couldn't allocate memory for b4xxp structure!\n");
+		ret = _RETVAL(ENOMEM);
+		goto err_out_release_regions;
+	}
+
+	b4->pdev = pdev;
+	b4->dev = &pdev->dev;
+	pci_set_drvdata(pdev, b4);
+	b4->ioaddr = pci_iomap(pdev, 0, 0);
+	b4->addr = pci_iomap(pdev, 1, 0);
+	b4->irq = pdev->irq;
+
+	ret = b4xxp_register(b4, dt);
+	if (ret)
+		goto err_out_free_mem;
+	return 0;
+
 err_out_free_mem:
 	pci_set_drvdata(pdev, NULL);
 	pci_iounmap(pdev, b4->ioaddr);
@@ -2838,24 +3224,17 @@
 
 err_out_disable_pdev:
 	pci_disable_device(pdev);
-
 	return ret;
 }
 
 static void __devexit b4xxp_remove(struct pci_dev *pdev)
 {
 	struct b4xxp *b4 = pci_get_drvdata(pdev);
-	int i;
 
 	if (b4) {
-		b4->shutdown = 1;
+		b4xxp_unregister(b4);
 
-		for (i=b4->numspans - 1; i >= 0; i--) {
-			dahdi_unregister(&b4->spans[i].span);
-		}
-
-		b4xxp_init_stage1(b4);
-		free_irq(pdev->irq, b4);
+		b4xxp_release_intr(b4);
 		pci_set_drvdata(pdev, NULL);
 		pci_iounmap(pdev, b4->ioaddr);
 		pci_iounmap(pdev, b4->addr);
@@ -2864,8 +3243,6 @@
 
 		b4->ioaddr = b4->addr = NULL;
 
-		tasklet_kill(&b4->b4xxp_tlet);
-
 		kfree(b4);
 	}
 
@@ -2873,30 +3250,14 @@
 	return;
 }
 
-static struct pci_device_id b4xx_ids[] __devinitdata =
-{
-	{ 0xd161, 0xb410, PCI_ANY_ID, PCI_ANY_ID, 0, 0, (unsigned long)&wcb4xxp },
-	{ 0x1397, 0x16b8, 0x1397, 0xe552, 0, 0, (unsigned long)&hfc8s },
-	{ 0x1397, 0x08b4, 0x1397, 0xb520, 0, 0, (unsigned long)&hfc4s },
-	{ 0x1397, 0x08b4, 0x1397, 0xb556, 0, 0, (unsigned long)&hfc2s },
-	{ 0x1397, 0x08b4, 0x1397, 0xe884, 0, 0, (unsigned long)&hfc2s_OV },
-	{ 0x1397, 0x08b4, 0x1397, 0xe888, 0, 0, (unsigned long)&hfc4s_OV },
-	{ 0x1397, 0x16b8, 0x1397, 0xe998, 0, 0, (unsigned long)&hfc8s_OV },
-	{ 0x1397, 0x08b4, 0x1397, 0xb566, 0, 0, (unsigned long)&hfc2s_BN },
-	{ 0x1397, 0x08b4, 0x1397, 0xb560, 0, 0, (unsigned long)&hfc4s_BN },
-	{ 0x1397, 0x16b8, 0x1397, 0xb562, 0, 0, (unsigned long)&hfc8s_BN },
-	{0, }
-
-};
-
-static struct pci_driver b4xx_driver = {
+static struct pci_driver b4xxp_driver = {
 	.name = "wcb4xxp",
-	.probe = b4xx_probe,
+	.probe = b4xxp_probe,
 	.remove = __devexit_p(b4xxp_remove),
-	.id_table = b4xx_ids,
+	.id_table = b4xxp_ids,
 };
 
-static int __init b4xx_init(void)
+static int __init b4xxp_init(void)
 {
 
 #ifdef CREATE_WCB4XXP_PROCFS_ENTRY
@@ -2905,18 +3266,18 @@
 		printk(KERN_ERR "%s: ERROR: Could not initialize /proc/%s\n",THIS_MODULE->name, PROCFS_NAME);
 	}
 #endif
-	if (dahdi_pci_module(&b4xx_driver))
+	if (dahdi_pci_module(&b4xxp_driver))
 		return -ENODEV;
 
 	return 0;
 }
 
-static void __exit b4xx_exit(void)
+static void __exit b4xxp_exit(void)
 {
 #ifdef CREATE_WCB4XXP_PROCFS_ENTRY
 	remove_proc_entry(PROCFS_NAME, NULL);
 #endif
-	pci_unregister_driver(&b4xx_driver);
+	pci_unregister_driver(&b4xxp_driver);
 }
 
 module_param(debug, int, S_IRUGO | S_IWUSR);
@@ -2949,7 +3310,8 @@
 MODULE_DESCRIPTION("B410P & Similars multi-port BRI module driver.");
 MODULE_LICENSE("GPL");
 
-MODULE_DEVICE_TABLE(pci, b4xx_ids);
+MODULE_DEVICE_TABLE(pci, b4xxp_ids);
 
-module_init(b4xx_init);
-module_exit(b4xx_exit);
+module_init(b4xxp_init);
+module_exit(b4xxp_exit);
+#endif /* !__FreeBSD__ */
Index: drivers/dahdi/dahdi_echocan_sec.c
===================================================================
--- drivers/dahdi/dahdi_echocan_sec.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_sec.c	(working copy)
@@ -36,6 +36,18 @@
    Improve double talk detector (iterative!)
 */
 
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/ctype.h>
+#include <sys/libkern.h>
+#include <sys/module.h>
+
+#define module_printk(level, fmt, args...) printf(fmt, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printf("%s: " fmt, __FUNCTION__, ## args)
+
+#else /* !__FreeBSD__ */
 #include <linux/kernel.h>
 #include <linux/slab.h>
 #include <linux/errno.h>
@@ -44,13 +56,14 @@
 #include <linux/ctype.h>
 #include <linux/moduleparam.h>
 
+#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printk(KERN_DEBUG "%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
+#endif /* !__FreeBSD__ */
+
 #include <dahdi/kernel.h>
 
 static int debug;
 
-#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
-#define debug_printk(level, fmt, args...) if (debug >= level) printk(KERN_DEBUG "%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
-
 #include "arith.h"
 
 #ifndef NULL
@@ -89,8 +102,10 @@
 
 static const struct dahdi_echocan_factory my_factory = {
 	.name = "SEC",
+	.echocan_create = echo_can_create,
+#if !defined(__FreeBSD__)
 	.owner = THIS_MODULE,
-	.echocan_create = echo_can_create,
+#endif
 };
 
 static const struct dahdi_echocan_features my_features = {
@@ -145,14 +160,13 @@
 
 	if (ecp->param_count > 0) {
 		printk(KERN_WARNING "SEC does not support parameters; failing request\n");
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	size = sizeof(*pvt) + ecp->tap_length * sizeof(int32_t) + ecp->tap_length * 3 * sizeof(int16_t);
-	
 	pvt = kzalloc(size, GFP_KERNEL);
 	if (!pvt)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	pvt->dahdi.ops = &my_ops;
 	pvt->dahdi.features = my_features;
@@ -333,7 +347,7 @@
 	if (dahdi_register_echocan_factory(&my_factory)) {
 		module_printk(KERN_ERR, "could not register with DAHDI core\n");
 
-		return -EPERM;
+		return _RETVAL(EPERM);
 	}
 
 	module_printk(KERN_NOTICE, "Registered echo canceler '%s'\n", my_factory.name);
@@ -346,6 +360,26 @@
 	dahdi_unregister_echocan_factory(&my_factory);
 }
 
+#if defined(__FreeBSD__)
+static int
+echocan_sec_modevent(module_t mod __unused, int type, void *data __unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		return mod_init();
+	case MOD_UNLOAD:
+		mod_exit();
+		return 0;
+	default:
+		return _RETVAL(EOPNOTSUPP);
+	}
+}
+
+DEV_MODULE(dahdi_echocan_sec, echocan_sec_modevent, NULL);
+MODULE_VERSION(dahdi_echocan_sec, 1);
+MODULE_DEPEND(dahdi_echocan_sec, dahdi, 1, 1, 1);
+
+#else /* !__FreeBSD__ */
 module_param(debug, int, S_IRUGO | S_IWUSR);
 
 MODULE_DESCRIPTION("DAHDI 'SEC' Echo Canceler");
@@ -354,3 +388,4 @@
 
 module_init(mod_init);
 module_exit(mod_exit);
+#endif /* !__FreeBSD__ */
Index: drivers/dahdi/dahdi_echocan_jpah.c
===================================================================
--- drivers/dahdi/dahdi_echocan_jpah.c	(revision 7107)
+++ drivers/dahdi/dahdi_echocan_jpah.c	(working copy)
@@ -26,6 +26,18 @@
  * this program for more details.
  */
 
+#if defined(__FreeBSD__)
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/conf.h>
+#include <sys/ctype.h>
+#include <sys/libkern.h>
+#include <sys/module.h>
+
+#define module_printk(level, fmt, args...) printf(fmt, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printf("%s: " fmt, __FUNCTION__, ## args)
+
+#else /* !__FreeBSD__ */
 #include <linux/kernel.h>
 #include <linux/errno.h>
 #include <linux/module.h>
@@ -33,13 +45,14 @@
 #include <linux/ctype.h>
 #include <linux/moduleparam.h>
 
+#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
+#define debug_printk(level, fmt, args...) if (debug >= level) printk("%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
+#endif /* !__FreeBSD__ */
+
 #include <dahdi/kernel.h>
 
 static int debug;
 
-#define module_printk(level, fmt, args...) printk(level "%s: " fmt, THIS_MODULE->name, ## args)
-#define debug_printk(level, fmt, args...) if (debug >= level) printk("%s (%s): " fmt, THIS_MODULE->name, __FUNCTION__, ## args)
-
 static int echo_can_create(struct dahdi_chan *chan, struct dahdi_echocanparams *ecp,
 			   struct dahdi_echocanparam *p, struct dahdi_echocan_state **ec);
 static void echo_can_free(struct dahdi_chan *chan, struct dahdi_echocan_state *ec);
@@ -48,8 +61,10 @@
 
 static const struct dahdi_echocan_factory my_factory = {
 	.name = "JPAH",
+	.echocan_create = echo_can_create,
+#if !defined(__FreeBSD__)
 	.owner = THIS_MODULE,
-	.echocan_create = echo_can_create,
+#endif
 };
 
 static const struct dahdi_echocan_ops my_ops = {
@@ -73,12 +88,12 @@
 
 	if (ecp->param_count > 0) {
 		printk(KERN_WARNING "JPAH does not support parameters; failing request\n");
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 	}
 
 	pvt = kzalloc(sizeof(*pvt), GFP_KERNEL);
 	if (!pvt)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	pvt->dahdi.ops = &my_ops;
 
@@ -121,7 +136,7 @@
 	if (dahdi_register_echocan_factory(&my_factory)) {
 		module_printk(KERN_ERR, "could not register with DAHDI core\n");
 
-		return -EPERM;
+		return _RETVAL(EPERM);
 	}
 
 	module_printk(KERN_NOTICE, "Registered echo canceler '%s'\n", my_factory.name);
@@ -134,6 +149,26 @@
 	dahdi_unregister_echocan_factory(&my_factory);
 }
 
+#if defined(__FreeBSD__)
+static int
+echocan_jpah_modevent(module_t mod __unused, int type, void *data __unused)
+{
+	switch (type) {
+	case MOD_LOAD:
+		return mod_init();
+	case MOD_UNLOAD:
+		mod_exit();
+		return 0;
+	default:
+		return _RETVAL(EOPNOTSUPP);
+	}
+}
+
+DEV_MODULE(dahdi_echocan_jpah, echocan_jpah_modevent, NULL);
+MODULE_VERSION(dahdi_echocan_jpah, 1);
+MODULE_DEPEND(dahdi_echocan_jpah, dahdi, 1, 1, 1);
+
+#else /* !__FreeBSD__ */
 module_param(debug, int, S_IRUGO | S_IWUSR);
 
 MODULE_DESCRIPTION("DAHDI Jason Parker Audio Hoser");
@@ -142,3 +177,4 @@
 
 module_init(mod_init);
 module_exit(mod_exit);
+#endif /* !__FreeBSD__ */
